
#########################################################
## ͏
# fBNg̕ύX-----------------------------------------------------
# R̃j[w肵Ă܂܂B
setwd("")


# pbP[W̓ǂݍ -------------------------------------------------
library(psych) 
library(GPArotation) 

# f[^̓ǂݍ ------------------------------------------------------

d0 <- read.csv("ch05.csv", header=TRUE)

# f[^̊mF -----------------------------------------------------------
head(d0)
tail(d0)
nrow(d0)

# f[^̌^̊mF ------------------------------------------------------
str(d0)

#########################################################
## 1. Ώێ҂̐ʓ̑mF
table(d0$gender, exclude=NULL)
table(d0$keiken, exclude=NULL)
table(d0$kihu, exclude=NULL)

#########################################################
## 2. lmFl̂f[^폜
d0[!complete.cases(d0),] 
d <- na.omit(d0)

#########################################################
## 3. ڕ
# xz̊mF ---------------------------------------------------------
# 20ڂ܂Ƃ߂ĈCɊmF
d_fa <- d[c("a01","a02","a03","a04","a05",
            "a06","a07","a08","a09","a10",
            "a11","a12","a13","a14","a15",
            "a16","a17","a18","a19","a20")]

sapply(d_fa, table, exclude=NULL)

# ϒlEW΍̊mF-------------------------------------------------
describe(d_fa) 

#########################################################
## 4. q́F20
# q͗pf[^t[̍쐬---------------------------------------
d_fa <- d[c("a01","a02","a03","a04","a05",
            "a06","a07","a08","a09","a10",
            "a11","a12","a13","a14","a15",
            "a16","a17","a18","a19","a20")]

# K؂Ȉq𐄑------------------------------------------------
# ŗLľ
tmp_c <- cor(d_fa)
eigen(tmp_c)
# XN[vbg
VSS.scree(d_fa)
# s
fa.parallel(d_fa)

# q------------------------------------------------------------------
# 3q̏ꍇ
result_3fa <- fa(d_fa, nfactors = 3, fm = "minres", rotate = "promax")
print(result_3fa, sort = TRUE)

# 4q̏ꍇ
result_4fa <- fa(d_fa, nfactors = 4, fm = "minres", rotate = "promax")
print(result_4fa, sort = TRUE)

#########################################################
#ȏ̂悤Ȉq͂JԂŗǂ̌ʂT
#########################################################
## 5. ŏIIȈq́F16
# f[^t[쐬
d_fa2<- d[c("a01","a02","a03","a04","a06","a07","a09","a10",
            "a11","a12","a13","a14","a15","a16","a17","a19")] 
# ŗLl̊mF
eigen(cor(d_fa2))
VSS.scree(d_fa2)
fa.parallel(d_fa2)
# q
result <- fa(d_fa2, nfactors = 3, fm = "minres", rotate = "promax")
print(result, sort = TRUE)

fa.plot(result, cut=.5)
fa.plot(result,labels=colnames(d_fa2),show.points=FALSE, cut=.5)

#########################################################
## 6. M̌
# IGꍇ
d_kanjo <- d[c("a02","a04","a01","a06","a03","a07")]
alpha(d_kanjo)
# ݗ
d_rikai <- d[c("a09","a13","a12","a11","a10")]
alpha(d_rikai)
# ւ̔z
d_kenri <- d[c("a17","a15","a14","a16","a19")]
alpha(d_kenri)

#########################################################
## 7. ړx_̎Zo
d$kanjo_score <- (d$a02 + d$a04 + d$a01 + d$a06 + d$a03 +
                    d$a07)/6
d$rikai_score <- (d$a09 + d$a13 + d$a12 + d$a11 + d$a10)/5
d$kenri_score <- (d$a17 + d$a15 + d$a14 + d$a16 + d$a19)/5

#########################################################
## 8. ړx_̕zALqvʂmF
#qXgO̊mF------------------------------------------------------
hist(d$kanjo_score, breaks=seq(1,5,0.5))
hist(d$rikai_score, breaks=seq(1,5,0.5))
hist(d$kenri_score, breaks=seq(1,5,0.5))

#LqvʂZo---------------------------------------------------------
d_sco <- d[c("kanjo_score", "rikai_score", "kenri_score")]
describe(d_sco)


#########################################################
## 9. oƎړx_̊֘Aioʂ̎ړx_̕zALqvʂmFj
#oꂼ̐lmF
table(d$keiken, exclude=NULL)

# eQ̕ϒl̗lmF
# ϒl
describeBy(d$kanjo_score, group = d$keiken)
describeBy(d$rikai_score, group = d$keiken)
describeBy(d$kenri_score, group = d$keiken)

# Ђ}
boxplot(d$kanjo_score ~ d$keiken, data = d)
boxplot(d$rikai_score ~ d$keiken, data = d)
boxplot(d$kenri_score ~ d$keiken, data = d)


#########################################################
## 10. ovƂPvU
# anovakun̓ǂݍ-----------------------------------------------------
source("anovakun_485.txt")

# anovakunŕ͂ł悤Ƀf[^t[쐬C
# IGꍇ
aov_kanjo <- d[c("keiken","kanjo_score")]
aov_kanjo <- aov_kanjo[order(aov_kanjo$keiken),]
anovakun(aov_kanjo, "As", 3, eta = TRUE)

# ݗ
aov_rikai <- d[c("keiken","rikai_score")]
aov_rikai <- aov_rikai[order(aov_rikai$keiken),]
anovakun(aov_rikai, "As", 3, eta = TRUE)

# ւ̔z
aov_kenri <- d[c("keiken","kenri_score")]
aov_kenri <- aov_kenri[order(aov_kenri$keiken),]
anovakun(aov_kenri, "As", 3, eta = TRUE)


#########################################################
## 11. toƎړx_̊֘Aitoʂ̎ړx_̕zALqvʂmFj
# toʂ̐lmF
table(d$kihu, exclude=NULL)

# eQ̕ϒl̗lmF
# ϒl
describeBy(d$kanjo_score, group = d$kihu)
describeBy(d$rikai_score, group = d$kihu)
describeBy(d$kenri_score, group = d$kihu)

# toʂɃf[^t[쐬
d_kihu_1 <- subset(d, d$kihu == 1)
d_kihu_2 <- subset(d, d$kihu == 2)

# IGꍇ
par(mfrow=c(1,2))
hist(d_kihu_1$kanjo_score, breaks=seq(1, 5, 0.5))
hist(d_kihu_2$kanjo_score, breaks=seq(1, 5, 0.5))

# IGꍇimxj
par(mfrow=c(1,2))
hist(d_kihu_1$kanjo_score, breaks=seq(1, 5, 0.5), freq = FALSE, ylim=c(0,0.6))
hist(d_kihu_2$kanjo_score, breaks=seq(1, 5, 0.5), freq = FALSE, ylim=c(0,0.6))


# ݗ
hist(d_kihu_1$rikai_score, breaks=seq(1, 5, 0.5))
hist(d_kihu_2$rikai_score, breaks=seq(1, 5, 0.5))

# ւ̔z
hist (d_kihu_1$kenri_score, breaks=seq(1, 5, 0.5))
hist (d_kihu_2$kenri_score, breaks=seq(1, 5, 0.5))

# oʂ̋_̕ϒlAW΍Zo
describeBy(d_sco , group = d$kihu)

#########################################################
## 12. Ή̂Ȃ t
#ǓAts
# IGꍇ
var.test(d$kanjo_score ~ d$kihu)
t.test(d$kanjo_score ~ d$kihu, var.equal = TRUE)

t.test(d$kanjo_score ~ d$kihu, var.equal = FALSE)

# ݗ
var.test(d$rikai_score ~ d$kihu)
t.test(d$rikai_score ~ d$kihu, var.equal = TRUE)

# ւ̔z
var.test(d$kenri_score ~ d$kihu)
t.test(d$kenri_score ~ d$kihu, var.equal =TRUE)


#########################################################
## 13. ʗʂ̎Zo
# eQ̐lCϒlCW΍ɑČvZ
# IGꍇ
(3.38 - 2.89) / sqrt(((32-1) * 0.78 ^ 2 + (228-1) * 0.82 ^ 2) / (32+228))
# ݗ
(3.17 - 2.76) / sqrt(((32-1) * 1.07 ^ 2 + (228-1) * 0.86 ^ 2) / (32+228))
# ւ̔z
(3.96 - 3.67) / sqrt(((32-1) * 0.64 ^ 2 + (228-1) * 0.76 ^ 2) / (32+228))

describeBy(d$kanjo_score , group = d$kihu, 3)
describeBy(d$rikai_score , group = d$kihu, 3)
describeBy(d$kenri_score , group = d$kihu, 3)

# IGꍇ
(3.375 - 2.891) / sqrt(((32-1) * 0.782 ^ 2 + (228-1) * 0.823 ^ 2) / (32+228))
# ݗ
(3.175 - 2.757) / sqrt(((32-1) * 1.073 ^ 2 + (228-1) * 0.859 ^ 2) / (32+228))
# ւ̔z
(3.963 - 3.668) / sqrt(((32-1) * 0.641 ^ 2 + (228-1) * 0.764 ^ 2) / (32+228))


##### ʗʂZo֐cohen_d()쐬ėp #####
# cohen_d()֐̒`
cohen_d <- function(x1,x2) {
  m1 <- mean(x1)
  m2 <- mean(x2)
  n1 <- length(x1)
  n2 <- length(x2)
  s1 <- sd(x1)
  s2 <- sd(x2)
  Sp <- sqrt(((n1-1)*s1^2+(n2-1)*s2^2)/(n1+n2))
  d <- (m1-m2)/Sp
  d
}

# cohen_d̓Kp
# IGꍇ
cohen_d(d_kihu_1$kanjo_score, d_kihu_2$kanjo_score)
# ݗ
cohen_d(d_kihu_1$rikai_score, d_kihu_2$rikai_score)
# ւ̔z
cohen_d(d_kihu_1$kenri_score, d_kihu_2$kenri_score)

