#########################################################
## ͏
# fBNg̕ύX-----------------------------------------------------
# R̃j[w肵Ă܂܂B
setwd("")

# pbP[W̓ǂݍ -------------------------------------------------
library(psych) 
library(ppcor) 
library(lavaan)

detach("package:lavaan") 

# f[^̓ǂݍ ------------------------------------------------------

d0 <- read.csv("ch06.csv", header=TRUE)

# f[^̊mF -----------------------------------------------------------
head(d0)
tail(d0)
nrow(d0)

# f[^̌^̊mF ------------------------------------------------------
str(d0)


#########################################################
## 1. lmFl̂f[^폜
d0[!complete.cases(d0),] 
d <- na.omit(d0)


#########################################################
## 2. ւ̋ړxڕ
# ϐɑ΂ĈCɓxz̍쐬w ----------------
lis_a <- c("a01", "a02", "a03", "a04", "a05", "a06", "a07",
           "a08", "a09", "a10", "a11", "a12", "a13", "a14", "a15", "a16")
sapply(d[lis_a], table, exclude=NULL)


d_a <- d[c("a01", "a02", "a03", "a04", "a05", "a06", "a07",
           "a08", "a09", "a10", "a11", "a12", "a13", "a14", "a15", "a16")]
sapply(d_a, table, exclude=NULL)


# Lqv------------------------------------------------------------------
describe(d[lis_a])

#########################################################
## 3. ɑ΂鋤ړx̊mFIq

# pbP[W̑
detach("package:psych") 
library(lavaan)

# mFIq͂̎s
model_cfa <- '
F_kanjo =~ a01 + a13 + a07 + a16 + a10 + a04
F_rikai =~ a02 + a08 + a14 + a11 + a05
F_kenri =~ a03 + a09 + a15 + a12 + a06
'

fit <- cfa(model_cfa, data=d, std.lv=TRUE)
summary(fit, standardized=TRUE, fit.measures = TRUE)  
fitmeasures(fit)
fitMeasures(fit,c("chisq", "df", "pvalue", "agfi","gfi","cfi","srmr","rmsea")) 

modi <- modindices(fit)
modi[order(modi$mi, decreasing=TRUE),]

detach("package:lavaan") 
library(psych)

#########################################################
## 4. M̌
# IGꍇ
lis_kanjo <- c("a01","a13","a07","a16","a10","a04")
alpha(d[lis_kanjo])
omega(d[lis_kanjo], plot =FALSE)
# ݗ
lis_rikai <- c("a02","a08","a14","a11","a05")
alpha(d[lis_rikai])
omega(d[lis_rikai], plot =FALSE)
# ւ̔z
lis_kenri <- c("a03","a09","a15","a12","a06")
alpha(d[lis_kenri])
omega(d[lis_kenri], plot =FALSE)


#########################################################
## 5. ʎړx_̎Zo
d$kanjo_score <- (d$a01 + d$a13 + d$a07 + d$a16 + d$a10 + d$a04)/6
d$rikai_score <- (d$a02 + d$a08 + d$a14 + d$a11 + d$a05)/5
d$kenri_score <- (d$a03 + d$a09 + d$a15 + d$a12 + d$a06)/5

#########################################################
## 6. eړx_̕zALqvʂmF
#qXgO̊mF------------------------------------------------------
par(mfrow=c(3,3))
hist(d$kanjo_score, breaks=seq(1,5,0.5))
hist(d$rikai_score, breaks=seq(1,5,0.5))
hist(d$kenri_score, breaks=seq(1,5,0.5))
hist(d$riyu1, breaks=seq(0,1,0.05))
hist(d$riyu2, breaks=seq(0,1,0.05))
hist(d$utsu, breaks=seq(4,20,2))
hist(d$hukai, breaks=seq(4,20,2))

#LqvʂZo---------------------------------------------------------
lis_1 <- c("kanjo_score","rikai_score","kenri_score", "riyu1", "riyu2", "utsu", "hukai")
describe(d[lis_1])

# XgX_3QɕĐlmF ------------------------
d$cut_u <- 2
d$cut_u[d$utsu <= 8] <- 1
d$cut_u[d$utsu >= 14] <- 3
table(d$cut_u)

d$cut_h <- 2
d$cut_h[d$hukai <= 8] <- 1
d$cut_h[d$hukai >= 14] <- 3
table(d$cut_h)

#########################################################
## 7. ֌WƕΑ֌WZo
#Uz}쐬 ------------------------------------------------------------
pairs(d[lis_1])

# ֌WZo----------------------------------------------------------
corr.test(d[lis_1]) 

tmp_r <- corr.test(d[lis_1]) 
names(tmp_r)
tmp_r$r

# Α֌WZo
pcor(d[lis_1])


###
qgraph::qgraph(cor(d[lis_1]),edge.labels=TRUE)

per.r2 <- pcor(d[lis_1])
qgraph::qgraph(per.r2$estimate,edge.labels=TRUE)
